<?php declare(strict_types=1);

namespace Plugin\css_artikel_list\Migrations;



use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
        error_log('starte copy '.$sourceDB);
        $result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
        if($copyTable && $result !== null && is_array($result) && count($result)) {
            error_log('DB Vorhanden '.$sourceDB);
            $result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
            foreach($result as $oItem) {
                error_log('schreibe Datensatz nach '.$destinationDB);
                $this->getDB()->insert($destinationDB,$oItem);
            }
        }
        if($deleteSourceDB) {
            $this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
        }
    }




    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_artikel_listConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `category_level` int(10) NOT NULL DEFAULT '1',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `sortierung` char(4) NOT NULL default 'ASC',
                  `onlyActiveAttribute` char(10) NOT NULL default 'off'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


        $this->copyTable("css_artikel_list_konfig","css_artikel_listConfig",true,false);


        $result = $this->getDB()->query(
            'SELECT * from `css_artikel_listConfig` where 1',
            2
        );

        if($result === null || count($result) < 1) {
           $this->execute(
            "INSERT INTO `css_artikel_listConfig` (`version`) VALUES ('2.0.0')"
            );
        } else {
            $this->execute("UPDATE css_artikel_listConfig set `version` = '2.0.0' ");
        }
    }

    /**
     * @inheritdoc
     */
    public function down() {
        if ($this->doDeleteData()) {
        }
    }
}
